\chapter{Outcome and future work}
\label{chap:conclusiones}

\lettrine{W}{hat} is \emph{learning}?

\quad That was the first question to be asked in this project report. Now, the truth is that we have reviewed a few algorithms that computers can use to \emph{learn}:
\begin{itemize}
	\item \textbf{Deep Q-Learning}: This algorithm approximates a value function through an ANN, but is very susceptible to variabilities in the environment which usually lead to unstable training. It was successfully used in the world of videogames because that provides the ideal conditions for evaluating limited and predictable problems, but still, I do not think it is suitable for real life problems. This works well for simpler problems where adaptation is not crucial.
	\item \textbf{Policy Gradients}: Because this algorithms attempts to approximate the \emph{agent policy} as a whole instead of playing a greedy policy over a value function, it is more powerful. However, a fine tuning of hyperparameters is very important in this algorithm because they affect the training process meaningfully.
	\item \textbf{Proximal Policy Optimization}: This is an algorithm belonging to the Policy Gradient family. However, it uses a \emph{clipped loss function} that prevents the policy from deviating too much from its previous values. This makes the training more stable, helps finding appropriate hyperparameters and makes the algorithm more adaptive. 
\end{itemize}

We have created a custom Gym environment in which we have tested these algorithms. OpenAI and RLlib projects were leveraged to build and evolve our environment.

We have also developed server and client applications for running and evaluating multiagent reinforcement learning environments, using Godot as rendering engine. A communication protocol between the Gym and Godot was implemented and formalised as PERLERT, a Protocol for Evaluating Reinforcement Learning Environments in Real Time.

Finally, some utilities to train and test agents using different hyperparameters have been added, and we have also opened up the challenge to train an agent that performs better than the PPO implementation from \scriptsize \texttt{RLlib}\normalsize. The project is actively maintained and could be the cradle for future research in the field of reinforcement learning.

\section{What now?}
\label{sec:whatnow}

In the future stages of this project, we consider:
\begin{itemize}
	\item Adding support for testing new algorithms and perform a research on their suitability for our custom environment.
	\item Keeping active research in reinforcement learning. \emph{Is the policy gradient a gradient?} is a paper \cite{ispolicygradientagradient} that questions the mathematical basis of the policy gradient theorem in relation to the discount factor. In special, it complains about a ``widespread misunderstanding regarding discounted policy gradient methods''. It is very relevant to properly understand the theorethical basis of whatever is put in practice. 
	\item Regaining focus on the multiagent part of the simulation. For that, instead of considering our problem a Markov Decision Process (MDP) where any state can be the result of a previous state and an action (see Figure~\ref{fig:basicrlprob}), we will discuss about interpreting the state as a tuple. First, what is perceived by the agent. Second, a hidden state whose dimension is unknown. For instance, if our \emph{zombie} perceives $(a, b, c, d)$ distance to walls, and $(x, y)$ distance to the \emph{citizen} (who is moving \emph{right}), then such state is not equivalent to a similar $(a, b, c, d, x, y)$ where \emph{citizen} is moving \emph{left}. Is there any possible way to train policies that take into account the existence of hidden information during the learning process? 
\end{itemize}
